<template>
    <div class="contSecc">
  <div class="gris">
    
      <div class="contSecc">
      <div class="divBuscador">
          <div>
              <v-text-field v-model="search" 
              class="buscador" append-icon="mdi-magnify" 
              label="Buscar..." 
              clearable
              single-line hide-details>
              </v-text-field>
          </div>
      </div>
 <!-- Boton añadir asignacion -->
          <div>
            <div class="btnCenter padding">
              <v-btn class="mt-5 " color="primary" dark @click="dialogAsignacion=true ">
                  <strong style="fond-size : 16px; color:#000;">Añadir Asignacion</strong>
              </v-btn>
            </div>
          </div>
        
          <!--  tabla-->
          <v-data-table :headers="encabezadoAsignacion" 
                        :items="asignaciones" 
                        :page.sync="page" 
                        :items-per-page="itemsPerPage" 
                        @page-count="pageCount = $event" 
                        :search="search" 
                        class="tblGeneral tblAsignacionGerente">
              <template v-slot:item.Eliminar="{ item }">
                  <button @click="(dialogElimina = true), (itemSeleccionado = item)">
                    <strong  >Eliminar</strong> 
                  </button>
              </template>
          </v-data-table>
          <!-- termina  tabla-->

            <!-- paginado
            <div class="text-center pt-10">
              <v-pagination v-model="page" :length="pageCount" class="paginador"></v-pagination>
          </div>
          -->
      </div>
      <!-- Dialog Elimina -->
      <v-dialog v-model="dialogElimina"  max-width="800" persistent >
          <v-card class="padding">
              <v-card-title class="headline">
                  <div class="titModal">
                      <div><strong>¿Deseas eliminar la visita?</strong></div>
                  </div>
              </v-card-title>
              <div class="contModal tCenter">
                  <div>
                      ¿Estás seguro que deseas eliminar la visita especial a:
                      <strong>{{this.itemSeleccionado.eco}}  </strong>
                      <strong>{{this.itemSeleccionado.nombreCeco}} para </strong>
                      <strong>{{this.itemSeleccionado.nombreUsuario}}</strong>
                  </div>
                  <div>
                    
                  </div>
              </div >
              <div class="btnCenter">
                  <v-btn color="grey" dark @click="dialogElimina = false" class="mr-10">
                      <strong style="fond-size : 16px; ">No, Conservar visita</strong>
                  </v-btn>
                  <v-btn color="primary" dark class=""
                  @click="(dialogConfimacion = true), (dialogElimina = false);   eliminaAsignacion(); ">
                      <strong style="fond-size : 16px; color:  #000;">Si, eliminar visita</strong>
                  </v-btn>
              </div>
          </v-card>
      </v-dialog>

      <!-- Dialog Confirmacion Eliminacion -->
      <v-dialog v-model="dialogConfimacion" max-width="600" persistent>
          <v-card class="padding">
              <v-card-title class="headline">
                  <div class="titModal">
                      <div><strong>Visita especial eliminada</strong></div>
                  </div>
              </v-card-title>
              <div class="contModal tCenter">
                  <div>
                      La visita a: 
                      <strong>{{this.itemSeleccionado.eco}}  </strong>
                      <strong>{{this.itemSeleccionado.nombreCeco}} para </strong>
                      <strong>{{this.itemSeleccionado.nombreUsuario}}</strong>
                      ,ha sido eliminada.
                  </div>
              </div>
              <div class="btnCenter" >
                  <v-btn color="primary" dark @click="dialogConfimacionAlta = false;dialogConfimacion=false">
                      <strong style="fond-size : 16px; color:  #000; ">¡De acuerdo!</strong>
                  </v-btn>
              </div>
          </v-card>
      </v-dialog>

      <!-- Dialog Confirmacion Alta -->
      <v-dialog v-model="dialogConfimacionAlta" max-width="600" persistent>
          <v-card class="padding">
              <v-card-title class="headline">
                  <div class="titModal">
                      <div><strong>Visita Asignada</strong></div>
                  </div>
              </v-card-title>
              <div class="contModal tCenter">
                  <div>
                      La visita especial a:
                      <Strong> CECO:
                      {{cecoSeleccionado.idCeco}} A
                      {{usuarioEncontrado.nombreUsuario}}
                      </Strong> 
                      ,ha sido Asignada.
                  </div>
              </div>
              <div class="btnCenter">
                  <v-btn color="primary" dark @click="dialogConfimacionAlta = false;altaAsignacion();">
                      <strong style="fond-size : 16px; color:  #000;">¡De acuerdo!</strong>
                  </v-btn>
              </div>
          </v-card>
      </v-dialog>

      <!-- Dialog dialogAsignacion -->

      <v-dialog v-model="dialogAsignacion" persistent max-width="600px">
          <v-card>
            <div class="gris">
                  <v-card-title class="headline">
                      <div class="titModal">
                          <div><strong>Alta Asignacion</strong></div>
                      </div>
                  </v-card-title>

                    <div class="contModal tCenter">
                        <strong>Ingresa datos para la asignación</strong>
                    </div>

                      <div class="divCol spaceCol">
                          <div class="col12">
                            <strong>Usuario a asignar:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-autocomplete
                                        ref="autoUsuario"
                                        v-model="usuarioEncontrado"
                                        :items="metadata.usuarios"
                                        clearable
                                        append-icon
                                        item-value="idUsuario"
                                        item-text="nombreUsuario"
                                        placeholder="Buscar Usuario"
                                        :search-input.sync="textoUsuarioIngresado"
                                        :rules="[!!usuarioEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        @keyup="actualizaUsuarios"
                                        return-object
                                        ></v-autocomplete>
                                 
                              </div>
                          </div>
                      </div>
                  
                  <div class="divCol spaceCol">
                          <div class="col12">
                            <strong>Negocio:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-select
                                      ref="autoNegocio"
                                        v-model="negocioSelecionado"
                                        :items="metadata.negocios"
                                        item-value="acronimo"
                                        item-text="descripcion"
                                        dense
                                        clearable
                                        hide-no-data
                                        append-icon
                                        placeholder="Buscar Negocio"
                                        :cache-items="false"
                                        @click="getNegocios"
                                        return-object
                                        ></v-select>
                                  <input type="submit" class="buscar" value @click="getNegocios()" />
                              </div>
                          </div>
                      </div>


                      <div class="divCol spaceCol">
                          <div class="col12">
                            <strong>Ceco a asignar:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-autocomplete
                                      ref="autoCeco"
                                        v-model="cecoSeleccionado"
                                        :items="metadata.cecos"
                                        item-text="ceco"
                                        clearable
                                        dense
                                        hide-no-data
                                        append-icon
                                        :disabled="habilitaSuc"
                                        placeholder="Buscar Ceco"
                                        :search-input.sync="textoIngresado"
                                        :rules="[() => !!cecoSeleccionado || 'Debes seleccionar un ceco',]"
                                        :cache-items="false"
                                        @keyup="actualizaCecos"
                                        return-object
                                        ></v-autocomplete>
                                  <input type="submit" class="buscar" value @click="getCecos()" />
                              </div>
                        </div>
                      </div>
                      <!-- Gerente -->
                         <div class="divCol spaceCol">
                          <div class="col12">
                            <strong>Gerente a asignar:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-autocomplete
                                        ref="autoGerente"
                                        v-model="gerenteEncontrado"
                                        :items="metadata.gerentes"
                                        clearable
                                        dense
                                        hide-no-data
                                        append-icon
                                        item-value="idUsuario"
                                        item-text="nombreUsuario"
                                        placeholder="Buscar Gerente"
                                        :search-input.sync="textoGerente"
                                        :rules="[!!gerenteEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        @keyup="actualizaUsuariosGerentes"
                                        return-object
                                        ></v-autocomplete>
                              </div>
                          </div>
                      </div>

                    <!-- Territorio
                     item-value="idUsuario"
                                        item-text="nombreUsuario"
                                        placeholder="Ingresa Territorio"
                                        :search-input.sync="textoGerente"
                                        :rules="[!!gerenteEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        @keyup="actualizaUsuariosGerentes" 
                                         hide-no-data
                                        append-icon-->
                         <div class="divCol spaceCol">
                          <div class="col12">
                            <strong   v-if="this.muestraGeo">Territorio:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-text-field
                                        ref="autoTerri"
                                        v-model="territorio"
                                        clearable
                                        dense
                                         placeholder="Ingresa Territorio"
                                        v-if="this.muestraGeo" 
                                        ></v-text-field>
                              </div>
                          </div>
                      </div>

                      <!-- Zona
                      :search-input.sync="textoGerente"
                                        :rules="[!!gerenteEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        @keyup="actualizaUsuariosGerentes" 
                                          item-value="idUsuario"
                                        item-text="nombreUsuario"
                                        placeholder="Ingresa Zona"
                                        -->
                         <div class="divCol spaceCol">
                          <div class="col12">
                            <strong  v-if="this.muestraGeo"> Zona:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-text-field
                                  class="form-control"
                                        ref="autoZona"
                                        v-model="zona"  
                                        clearable
                                        dense
                                        append-icon
                                        placeholder="Ingresa Zona"
                                        v-if="this.muestraGeo"
                                        ></v-text-field>
                              </div>
                          </div>
                      </div>



              <div class="btnCenter">
                  <v-btn color="grey" dark @click="dialogAsignacion=false;limpiaFormulario()" class="mr-10">
                      <strong style="fond-size :16px; color: #000;">Cancelar</strong>
                  </v-btn>
                  <v-btn color="primary" dark @click="dialogConfimacionAlta=true;dialogAsignacion=false;altaAsignaGeo()">
                      <strong style="fond-size : 16px; color:  #000;">Guardar</strong>
                  </v-btn>
              </div>
            </div>
          </v-card>

      </v-dialog>

  </div>
</div>
</template>

<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
export default {
    name: "tabla-visor-asignacion",

    data() {
        return {
        
          cecoIngresado: "",
          cecoSeleccionado: "",
          cecosEncontrados: [],
          usuarioEncontrado:"",
          textoIngresado: "",
          itemSeleccionado: "",
          negocioSelecionado:"",
          textoUsuarioIngresado:"",
          habilitaSuc:true,
          gerenteEncontrado:"",
          textoGerente:"",
          muestraGeo:false,
          zona:"",
          territorio:"",
          //dialogs
          dialogConfimacionAlta:false,
          dialogElimina: false,
          dialogConfimacion: false,
          dialogAsignacion: false,

          pageCount: 1,
          page: 1,
          itemsPerPage: 20,
          search: "",
          propiedades_footer: {
            itemsPerPageOptions: [2, 4, 5, 10],
          },
          encabezadoAsignacion: [
            {
              text: "Economico",
              value: "eco",
              align: "center",
            },
            {
                    text: "Nombre Sucursal",
                    value: "nombreCeco",
                    align: "center",
                },
                {
                    text: "Visita",
                    value: "acronimo",
                    align: "center",
                },
                {
                    text: "No.Empleado",
                    value: "idUsuario",
                    align: "center",
                },
                {
                    text: "Nombre Visitante",
                    value: "nombreUsuario",
                    align: "center",
                },
                {
                    text: "Eliminar",
                    value: "Eliminar",
                    align: "center",
                },
            ],
            asignaciones: [],
            metadata: {
              cecos: [],
              usuarios: [],
              negocios: [],
              gerentes:[],
        },
        breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia",
          },
        },
        {
          text: "Protocolos",
          disabled: true,
        },
      ],
      };
    },
    created() {
        this.getAsignaciones();
       // this.getNegocios();
    },
    methods: {
        getAsignaciones() {
            axios
                .post("asignacion-sup/secure/post/asignacionsup", {
                    idPerfil: 1,
                })
                .then((response) => {
                 
                    if (response) {
                        if (response.status === 200) {
                            this.asignaciones = response.data.data;
                            // console.log(response.data.data)
                        }
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});
        },
        eliminaAsignacion() {
            //  alert(JSON.stringify(this.itemSeleccionado));
            axios
                .delete("/asignacion-sup/secure/delete/asignacion", {
                    data: {
                        idUsuario: this.itemSeleccionado.idUsuario,
                        idCeco: this.itemSeleccionado.idCeco,
                    },
                })
                .then((response) => {
                    this.getAsignaciones();
                    
                    if (response === 200 && response.data === 1) {
                        this.dialogConfimacion = true;
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});

        },
        //Inicia cecos
        getCecos() {
            axios
                .post("negoVers/secure/post/cecos", {
                    prefijo: this.prefijo,
                    idCeco: this.ceco,
                    nombreCeco: this.nombre,
                })
                .then((response) => {
                  //console.log(JSON.stringify(response.data.data))
                    if (response) {
                        if (response.status === 200) {
                            this.metadata.cecos = [];

                            for (var i = 0; i < response.data.data.length; i++) {
                                this.metadata.cecos.push({
                                  nombreCeco:response.data.data[i].nombreCeco,
                                    ceco: response.data.data[i].nombreCeco +
                                        " - " +
                                        response.data.data[i].idCeco,
                                    idCeco: response.data.data[i].idCeco,
                                });
                            }
                        }
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});
        },
         actualizaCecos() {
        if (this.textoIngresado!= null  && this.textoIngresado.length>3   && this.negocioSelecionado.idNegocio ==1 ) {
                this.prefijo = 92;
                this.ceco = null;
                this.nombre = this.textoIngresado;
                this.muestraGeo=true;
                this.getCecos();
            } else if(this.textoIngresado !=null && this.textoIngresado.length>3 && this.negocioSelecionado.idNegocio !=1){
                    this.prefijo=55;
                    this.ceco=null;
                    this.nombre=this.textoIngresado;
                    this.muestraGeo=false;
                    this.getCecos();
            }
            else {
                this.metadata.cecos = [];
            }
        },
        //finaliza cecos
        /* INICIA USUARIOS */
        getUsuarios() {
              axios
                .post("/negoVers/secure/post/usuarios", {
                  id_usuario: this.idUsuario,
                  nombreUsuario: this.nombreUsuario,
                  idPuesto: this.idPuesto,
                })
                .then((response) => {
                  if (response) {
                    if (response.status === 200) {
                      if (response.data.data != undefined) {
                        this.metadata.usuarios = response.data.data;
                        //console.log(JSON.stringify(this.metadata.usuarios))
                      }
                    }
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
            },
            actualizaUsuarios() {
              if ( this.textoUsuarioIngresado != null && this.textoUsuarioIngresado.length > 3 ) {
                this.getUsuarios();
              }else{
                    this.metadata.usuarios=[];
              }
            },
            /* FIN USUARIOS */
            /* INICIA GERENTES */
        getUsuariosGerentes() {
              axios
                .post("/negoVers/secure/post/usuarios", {
                  id_usuario: this.idUsuario,
                  nombreUsuario: this.nombreUsuario,
                  idPuesto: this.idPuesto,
                })
                .then((response) => {
                  if (response) {
                    if (response.status === 200) {
                      if (response.data.data != undefined) {
                        this.metadata.gerentes = response.data.data;
                        //console.log("entro")
                       // console.log(JSON.stringify(this.metadata.gerentes))
                      }
                    }
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
            },
            actualizaUsuariosGerentes() {
              if ( this.textoGerente != null && this.textoGerente.length > 3 ) {
                this.getUsuariosGerentes();
              }else{
                    this.metadata.gerentes=[];
              }
            },
            /* FIN GERENTES */
              //OBTIENEN negocios
            getNegocios() {
              axios
                .post("/negoVers/secure/post/negocio", {
                  idNegocio: null,
                })
                .then((response) => {
                  if (response) {
                    if (response.status === 200) {
                      if (response.data.data != undefined) {
                        this.metadata.negocios = response.data.data;
                        this.habilitaSuc=false;
                        this.muestraGeo=false,
                          this.metadata.cecos=[];
                      }
                    }
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
                
            },    //fin negocios
            //ALTA ASIGNACION
            altaAsignacion() {
              this.objAdd = {
                idUsuario: this.usuarioEncontrado.idUsuario,
                idCeco: this.cecoSeleccionado.idCeco,
                idPerfil: 1,
                idNegocio: this.negocioSelecionado.idNegocio,
                idGerente: this.gerenteEncontrado.idUsuario,
              };
              axios
                .post("asignacion-sup/secure/post/alta/asignacion", this.objAdd)
                .then((response) => {
                  if(this.objAdd.idUsuario != null && this.objAdd.idCeco != null && this.objAdd.idNegocio != null)
                    {
                  //alert("datos" + JSON.stringify(this.objAdd));
                    if (response) {
              if (response.status == 200) {
                if( response.data.data==1){
                this.dialog = false;
                this.dialogConfimacionAlta=false;
                this.dialogAsignacion=false;
                this.getAsignaciones();
                this.habilitaSuc=true;
                }
              } else {
                //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
                this.dialogFallo = true;
                 this.habilitaSuc=true;
              }
            }    
          } else {
            //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
            this.dialogFallo = true;
                this.usuarioEncontrado = "";
                this.cecoSeleccionado = "";
                this.listaTipoNego = "";
                this.metadata.cecos=[];
                this.metadata.usuarios=[];
                this.$refs.autoUsuario.resetValidation();
                this.$refs.autoCeco.resetValidation();
                this.$refs.autoGerente.resetValidation();
                this.dialogAsignacion=true;
                this.habilitaSuc=false;
                this.muestraGeo=false;
                this.zona="";
                this.territorio="";

          }
                this.usuarioEncontrado = "";
                this.cecoSeleccionado = "";
                this.listaTipoNego = "";
                this.metadata.cecos=[];
                this.metadata.negocios=[];
                this.metadata.usuarios=[];
                this.metadata.gerentes=[];
                this.$refs.autoUsuario.resetValidation();
                this.$refs.autoCeco.resetValidation();
                this.$refs.autoGerente.resetValidation();
                this.muestraGeo=false;
                this.zona="";
                this.territorio="";

                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
            },
            limpiaFormulario(){
                                 this.usuarioEncontrado = "";
                                this.cecoSeleccionado = "";
                                this.listaTipoNego = "";
                                this.metadata.cecos=[];
                                this.metadata.negocios=[];
                                this.metadata.usuarios=[];
                                this.metadata.gerentes=[];
                                this.$refs.autoUsuario.resetValidation();
                                this.$refs.autoCeco.resetValidation();
                                 this.$refs.autoGerente.resetValidation();
                                this.habilitaSuc=true;
                                this.muestraGeo=false;
                                this.zona="";
                                this.territorio="";


            },
             altaAsignaGeo() {
              this.objAdd = {
                nombre: this.cecoSeleccionado.nombreCeco,
                id_ceco: this.cecoSeleccionado.idCeco,
                activo: 1,
                territorio: this.territorio,
                zona: this.zona,
              };
              //console.log(JSON.stringify(this.cecoSeleccionado))
               //console.log("datos" + JSON.stringify(this.objAdd));
              axios
                .post("franquicia/asignacion/certificacion/calidad/secure/geo/post", this.objAdd)
                .then((response) => {
                  //console.log("alta geo")
                  console.log("datos" + JSON.stringify(this.objAdd));
                  if (response) {
                    if (response.status == 200) {
                      if( response.data.data==1){
                        console.log("Asignacion Geo" + JSON.stringify(this.objAdd));
                      }
                    }
                  }
             })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
            },
            
    },// fin metodos
    
    
};
</script>

<style>
.padding{
  padding-bottom: 25px;
}

</style>
<template>
    <div class="contSecc">
  <div class="gris">
    
      <div class="contSecc">
      <div class="divBuscador">
          <div>
              <v-text-field v-model="search" 
              class="buscador" append-icon="mdi-magnify" 
              label="Buscar..." 
              clearable
              single-line hide-details>
              </v-text-field>
          </div>
      </div>
 <!-- Boton añadir asignacion -->
          <div>
            <div class="btnCenter padding">
              <v-btn class="mt-5 " color="primary" dark @click="dialogAsignacion=true ">
                  <strong style="fond-size : 16px; color:#000;">Añadir Asignacion</strong>
              </v-btn>
            </div>
          </div>
        
          <!--  tabla-->
          <v-data-table :headers="encabezadoAsignacion" 
                        :items="asignaciones" 
                        :page.sync="page" 
                        :items-per-page="itemsPerPage" 
                        @page-count="pageCount = $event" 
                        :search="search" 
                        class="tblGeneral tblAsignacionGerente">
              <template v-slot:item.Eliminar="{ item }">
                  <button @click="(dialogElimina = true), (itemSeleccionado = item)">
                    <strong  >Eliminar</strong> 
                  </button>
              </template>
          </v-data-table>
          <!-- termina  tabla-->

            <!-- paginado
            <div class="text-center pt-10">
              <v-pagination v-model="page" :length="pageCount" class="paginador"></v-pagination>
          </div>
          -->
      </div>
      <!-- Dialog Elimina -->
      <v-dialog v-model="dialogElimina"  max-width="800" persistent >
          <v-card class="padding">
              <v-card-title class="headline">
                  <div class="titModal">
                      <div><strong>¿Deseas eliminar la visita?</strong></div>
                  </div>
              </v-card-title>
              <div class="contModal tCenter">
                  <div>
                      ¿Estás seguro que deseas eliminar la visita especial a:
                      <strong>{{this.itemSeleccionado.eco}}  </strong>
                      <strong>{{this.itemSeleccionado.nombreCeco}} para </strong>
                      <strong>{{this.itemSeleccionado.nombreUsuario}}</strong>
                  </div>
                  <div>
                    
                  </div>
              </div >
              <div class="btnCenter">
                  <v-btn color="grey" dark @click="dialogElimina = false" class="mr-10">
                      <strong style="fond-size : 16px; ">No, Conservar visita</strong>
                  </v-btn>
                  <v-btn color="primary" dark class=""
                  @click="(dialogConfimacion = true), (dialogElimina = false);   eliminaAsignacion(); ">
                      <strong style="fond-size : 16px; color:  #000;">Si, eliminar visita</strong>
                  </v-btn>
              </div>
          </v-card>
      </v-dialog>

      <!-- Dialog Confirmacion Eliminacion -->
      <v-dialog v-model="dialogConfimacion" max-width="600" persistent>
          <v-card class="padding">
              <v-card-title class="headline">
                  <div class="titModal">
                      <div><strong>Visita especial eliminada</strong></div>
                  </div>
              </v-card-title>
              <div class="contModal tCenter">
                  <div>
                      La visita a: 
                      <strong>{{this.itemSeleccionado.eco}}  </strong>
                      <strong>{{this.itemSeleccionado.nombreCeco}} para </strong>
                      <strong>{{this.itemSeleccionado.nombreUsuario}}</strong>
                      ,ha sido eliminada.
                  </div>
              </div>
              <div class="btnCenter" >
                  <v-btn color="primary" dark @click="dialogConfimacionAlta = false;dialogConfimacion=false">
                      <strong style="fond-size : 16px; color:  #000; ">¡De acuerdo!</strong>
                  </v-btn>
              </div>
          </v-card>
      </v-dialog>

      <!-- Dialog Confirmacion Alta -->
      <v-dialog v-model="dialogConfimacionAlta" max-width="600" persistent>
          <v-card class="padding">
              <v-card-title class="headline">
                  <div class="titModal">
                      <div><strong>Visita Asignada</strong></div>
                  </div>
              </v-card-title>
              <div class="contModal tCenter">
                  <div>
                      La visita especial a:
                      <Strong> CECO:
                      {{cecoSeleccionado.idCeco}} A
                      {{usuarioEncontrado.nombreUsuario}}
                      </Strong> 
                      ,ha sido Asignada.
                  </div>
              </div>
              <div class="btnCenter">
                  <v-btn color="primary" dark @click="dialogConfimacionAlta = false;altaAsignacion();">
                      <strong style="fond-size : 16px; color:  #000;">¡De acuerdo!</strong>
                  </v-btn>
              </div>
          </v-card>
      </v-dialog>

      <!-- Dialog dialogAsignacion -->

      <v-dialog v-model="dialogAsignacion" persistent max-width="600px">
          <v-card>
            <div class="gris">
                  <v-card-title class="headline">
                      <div class="titModal">
                          <div><strong>Alta Asignacion</strong></div>
                      </div>
                  </v-card-title>

                    <div class="contModal tCenter">
                        <strong>Ingresa datos para la asignación</strong>
                    </div>

                      <div class="divCol spaceCol">
                          <div class="col12">
                            <strong>Usuario a asignar:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-autocomplete
                                        ref="autoUsuario"
                                        v-model="usuarioEncontrado"
                                        :items="metadata.usuarios"
                                        clearable
                                        append-icon
                                        item-value="idUsuario"
                                        item-text="nombreUsuario"
                                        placeholder="Buscar Usuario"
                                        :search-input.sync="textoUsuarioIngresado"
                                        :rules="[!!usuarioEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        @keyup="actualizaUsuarios"
                                        return-object
                                        ></v-autocomplete>
                                 
                              </div>
                          </div>
                      </div>
                  
                  <div class="divCol spaceCol">
                          <div class="col12">
                            <strong>Negocio:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-select
                                      ref="autoNegocio"
                                        v-model="negocioSelecionado"
                                        :items="metadata.negocios"
                                        item-value="acronimo"
                                        item-text="descripcion"
                                        dense
                                        clearable
                                        hide-no-data
                                        append-icon
                                        placeholder="Buscar Negocio"
                                        :cache-items="false"
                                        @click="getNegocios"
                                        return-object
                                        ></v-select>
                                  <input type="submit" class="buscar" value @click="getNegocios()" />
                              </div>
                          </div>
                      </div>


                      <div class="divCol spaceCol">
                          <div class="col12">
                            <strong>Ceco a asignar:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-autocomplete
                                      ref="autoCeco"
                                        v-model="cecoSeleccionado"
                                        :items="metadata.cecos"
                                        item-text="ceco"
                                        clearable
                                        dense
                                        hide-no-data
                                        append-icon
                                        :disabled="habilitaSuc"
                                        placeholder="Buscar Ceco"
                                        :search-input.sync="textoIngresado"
                                        :rules="[() => !!cecoSeleccionado || 'Debes seleccionar un ceco',]"
                                        :cache-items="false"
                                        @keyup="actualizaCecos"
                                        return-object
                                        ></v-autocomplete>
                                  <input type="submit" class="buscar" value @click="getCecos()" />
                              </div>
                        </div>
                      </div>
                      <!-- Gerente -->
                         <div class="divCol spaceCol">
                          <div class="col12">
                            <strong>Gerente a asignar:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-autocomplete
                                        ref="autoGerente"
                                        v-model="gerenteEncontrado"
                                        :items="metadata.gerentes"
                                        clearable
                                        dense
                                        hide-no-data
                                        append-icon
                                        item-value="idUsuario"
                                        item-text="nombreUsuario"
                                        placeholder="Buscar Gerente"
                                        :search-input.sync="textoGerente"
                                        :rules="[!!gerenteEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        @keyup="actualizaUsuariosGerentes"
                                        return-object
                                        ></v-autocomplete>
                              </div>
                          </div>
                      </div>

                    <!-- Territorio
                     item-value="idUsuario"
                                        item-text="nombreUsuario"
                                        placeholder="Ingresa Territorio"
                                        :search-input.sync="textoGerente"
                                        :rules="[!!gerenteEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        @keyup="actualizaUsuariosGerentes" 
                                         hide-no-data
                                        append-icon-->
                         <div class="divCol spaceCol">
                          <div class="col12">
                            <strong   v-if="this.muestraGeo">Territorio:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-text-field
                                        ref="autoTerri"
                                        v-model="territorio"
                                        clearable
                                        dense
                                         placeholder="Ingresa Territorio"
                                        v-if="this.muestraGeo" 
                                        ></v-text-field>
                              </div>
                          </div>
                      </div>

                      <!-- Zona
                      :search-input.sync="textoGerente"
                                        :rules="[!!gerenteEncontrado || 'Debes Seleccionar un usuario']"
                                        :cache-items="false"
                                        @keyup="actualizaUsuariosGerentes" 
                                          item-value="idUsuario"
                                        item-text="nombreUsuario"
                                        placeholder="Ingresa Zona"
                                        -->
                         <div class="divCol spaceCol">
                          <div class="col12">
                            <strong  v-if="this.muestraGeo"> Zona:</strong> 
                              <br>
                              <div class="pRelative">
                                  <v-text-field
                                  class="form-control"
                                        ref="autoZona"
                                        v-model="zona"  
                                        clearable
                                        dense
                                        append-icon
                                        placeholder="Ingresa Zona"
                                        v-if="this.muestraGeo"
                                        ></v-text-field>
                              </div>
                          </div>
                      </div>



              <div class="btnCenter">
                  <v-btn color="grey" dark @click="dialogAsignacion=false;limpiaFormulario()" class="mr-10">
                      <strong style="fond-size :16px; color: #000;">Cancelar</strong>
                  </v-btn>
                  <v-btn color="primary" dark @click="dialogConfimacionAlta=true;dialogAsignacion=false;altaAsignaGeo()">
                      <strong style="fond-size : 16px; color:  #000;">Guardar</strong>
                  </v-btn>
              </div>
            </div>
          </v-card>

      </v-dialog>

  </div>
</div>
</template>

<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
export default {
    name: "tabla-visor-asignacion",

    data() {
        return {
        
          cecoIngresado: "",
          cecoSeleccionado: "",
          cecosEncontrados: [],
          usuarioEncontrado:"",
          textoIngresado: "",
          itemSeleccionado: "",
          negocioSelecionado:"",
          textoUsuarioIngresado:"",
          habilitaSuc:true,
          gerenteEncontrado:"",
          textoGerente:"",
          muestraGeo:false,
          zona:"",
          territorio:"",
          //dialogs
          dialogConfimacionAlta:false,
          dialogElimina: false,
          dialogConfimacion: false,
          dialogAsignacion: false,

          pageCount: 1,
          page: 1,
          itemsPerPage: 20,
          search: "",
          propiedades_footer: {
            itemsPerPageOptions: [2, 4, 5, 10],
          },
          encabezadoAsignacion: [
            {
              text: "Economico",
              value: "eco",
              align: "center",
            },
            {
                    text: "Nombre Sucursal",
                    value: "nombreCeco",
                    align: "center",
                },
                {
                    text: "Visita",
                    value: "acronimo",
                    align: "center",
                },
                {
                    text: "No.Empleado",
                    value: "idUsuario",
                    align: "center",
                },
                {
                    text: "Nombre Visitante",
                    value: "nombreUsuario",
                    align: "center",
                },
                {
                    text: "Eliminar",
                    value: "Eliminar",
                    align: "center",
                },
            ],
            asignaciones: [],
            metadata: {
              cecos: [],
              usuarios: [],
              negocios: [],
              gerentes:[],
        },
        breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia",
          },
        },
        {
          text: "Protocolos",
          disabled: true,
        },
      ],
      };
    },
    created() {
        this.getAsignaciones();
       // this.getNegocios();
    },
    methods: {
        getAsignaciones() {
            axios
                .post("asignacion-sup/secure/post/asignacionsup", {
                    idPerfil: 1,
                })
                .then((response) => {
                 
                    if (response) {
                        if (response.status === 200) {
                            this.asignaciones = response.data.data;
                            // console.log(response.data.data)
                        }
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});
        },
        eliminaAsignacion() {
            //  alert(JSON.stringify(this.itemSeleccionado));
            axios
                .delete("/asignacion-sup/secure/delete/asignacion", {
                    data: {
                        idUsuario: this.itemSeleccionado.idUsuario,
                        idCeco: this.itemSeleccionado.idCeco,
                    },
                })
                .then((response) => {
                    this.getAsignaciones();
                    
                    if (response === 200 && response.data === 1) {
                        this.dialogConfimacion = true;
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});

        },
        //Inicia cecos
        getCecos() {
            axios
                .post("negoVers/secure/post/cecos", {
                    prefijo: this.prefijo,
                    idCeco: this.ceco,
                    nombreCeco: this.nombre,
                })
                .then((response) => {
                  //console.log(JSON.stringify(response.data.data))
                    if (response) {
                        if (response.status === 200) {
                            this.metadata.cecos = [];

                            for (var i = 0; i < response.data.data.length; i++) {
                                this.metadata.cecos.push({
                                  nombreCeco:response.data.data[i].nombreCeco,
                                    ceco: response.data.data[i].nombreCeco +
                                        " - " +
                                        response.data.data[i].idCeco,
                                    idCeco: response.data.data[i].idCeco,
                                });
                            }
                        }
                    }
                })
                .catch((error) => {
                    console.log(error);
                })
                .finally(function () {});
        },
         actualizaCecos() {
        if (this.textoIngresado!= null  && this.textoIngresado.length>3   && this.negocioSelecionado.idNegocio ==1 ) {
                this.prefijo = 92;
                this.ceco = null;
                this.nombre = this.textoIngresado;
                this.muestraGeo=true;
                this.getCecos();
            } else if(this.textoIngresado !=null && this.textoIngresado.length>3 && this.negocioSelecionado.idNegocio !=1){
                    this.prefijo=55;
                    this.ceco=null;
                    this.nombre=this.textoIngresado;
                    this.muestraGeo=false;
                    this.getCecos();
            }
            else {
                this.metadata.cecos = [];
            }
        },
        //finaliza cecos
        /* INICIA USUARIOS */
        getUsuarios() {
              axios
                .post("/negoVers/secure/post/usuarios", {
                  id_usuario: this.idUsuario,
                  nombreUsuario: this.nombreUsuario,
                  idPuesto: this.idPuesto,
                })
                .then((response) => {
                  if (response) {
                    if (response.status === 200) {
                      if (response.data.data != undefined) {
                        this.metadata.usuarios = response.data.data;
                        //console.log(JSON.stringify(this.metadata.usuarios))
                      }
                    }
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
            },
            actualizaUsuarios() {
              if ( this.textoUsuarioIngresado != null && this.textoUsuarioIngresado.length > 3 ) {
                this.getUsuarios();
              }else{
                    this.metadata.usuarios=[];
              }
            },
            /* FIN USUARIOS */
            /* INICIA GERENTES */
        getUsuariosGerentes() {
              axios
                .post("/negoVers/secure/post/usuarios", {
                  id_usuario: this.idUsuario,
                  nombreUsuario: this.nombreUsuario,
                  idPuesto: this.idPuesto,
                })
                .then((response) => {
                  if (response) {
                    if (response.status === 200) {
                      if (response.data.data != undefined) {
                        this.metadata.gerentes = response.data.data;
                        //console.log("entro")
                       // console.log(JSON.stringify(this.metadata.gerentes))
                      }
                    }
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
            },
            actualizaUsuariosGerentes() {
              if ( this.textoGerente != null && this.textoGerente.length > 3 ) {
                this.getUsuariosGerentes();
              }else{
                    this.metadata.gerentes=[];
              }
            },
            /* FIN GERENTES */
              //OBTIENEN negocios
            getNegocios() {
              axios
                .post("/negoVers/secure/post/negocio", {
                  idNegocio: null,
                })
                .then((response) => {
                  if (response) {
                    if (response.status === 200) {
                      if (response.data.data != undefined) {
                        this.metadata.negocios = response.data.data;
                        this.habilitaSuc=false;
                        this.muestraGeo=false,
                          this.metadata.cecos=[];
                      }
                    }
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
                
            },    //fin negocios
            //ALTA ASIGNACION
            altaAsignacion() {
              this.objAdd = {
                idUsuario: this.usuarioEncontrado.idUsuario,
                idCeco: this.cecoSeleccionado.idCeco,
                idPerfil: 1,
                idNegocio: this.negocioSelecionado.idNegocio,
                idGerente: this.gerenteEncontrado.idUsuario,
              };
              axios
                .post("asignacion-sup/secure/post/alta/asignacion", this.objAdd)
                .then((response) => {
                  if(this.objAdd.idUsuario != null && this.objAdd.idCeco != null && this.objAdd.idNegocio != null)
                    {
                  //alert("datos" + JSON.stringify(this.objAdd));
                    if (response) {
              if (response.status == 200) {
                if( response.data.data==1){
                this.dialog = false;
                this.dialogConfimacionAlta=false;
                this.dialogAsignacion=false;
                this.getAsignaciones();
                this.habilitaSuc=true;
                }
              } else {
                //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
                this.dialogFallo = true;
                 this.habilitaSuc=true;
              }
            }    
          } else {
            //alert("no Jalo la asignacion" + JSON.stringify(this.objAdd));
            this.dialogFallo = true;
                this.usuarioEncontrado = "";
                this.cecoSeleccionado = "";
                this.listaTipoNego = "";
                this.metadata.cecos=[];
                this.metadata.usuarios=[];
                this.$refs.autoUsuario.resetValidation();
                this.$refs.autoCeco.resetValidation();
                this.$refs.autoGerente.resetValidation();
                this.dialogAsignacion=true;
                this.habilitaSuc=false;
                this.muestraGeo=false;
                this.zona="";
                this.territorio="";

          }
                this.usuarioEncontrado = "";
                this.cecoSeleccionado = "";
                this.listaTipoNego = "";
                this.metadata.cecos=[];
                this.metadata.negocios=[];
                this.metadata.usuarios=[];
                this.metadata.gerentes=[];
                this.$refs.autoUsuario.resetValidation();
                this.$refs.autoCeco.resetValidation();
                this.$refs.autoGerente.resetValidation();
                this.muestraGeo=false;
                this.zona="";
                this.territorio="";

                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
            },
            limpiaFormulario(){
                                 this.usuarioEncontrado = "";
                                this.cecoSeleccionado = "";
                                this.listaTipoNego = "";
                                this.metadata.cecos=[];
                                this.metadata.negocios=[];
                                this.metadata.usuarios=[];
                                this.metadata.gerentes=[];
                                this.$refs.autoUsuario.resetValidation();
                                this.$refs.autoCeco.resetValidation();
                                 this.$refs.autoGerente.resetValidation();
                                this.habilitaSuc=true;
                                this.muestraGeo=false;
                                this.zona="";
                                this.territorio="";


            },
             altaAsignaGeo() {
              this.objAdd = {
                nombre: this.cecoSeleccionado.nombreCeco,
                id_ceco: this.cecoSeleccionado.idCeco,
                activo: 1,
                territorio: this.territorio,
                zona: this.zona,
              };
              //console.log(JSON.stringify(this.cecoSeleccionado))
               //console.log("datos" + JSON.stringify(this.objAdd));
              axios
                .post("franquicia/asignacion/certificacion/calidad/secure/geo/post", this.objAdd)
                .then((response) => {
                  //console.log("alta geo")
                  console.log("datos" + JSON.stringify(this.objAdd));
                  if (response) {
              if (response.status == 200) {
                if( response.data.data==1){
                 console.log("Asignacion Geo" + JSON.stringify(this.objAdd));
                }
              } 
            }    
          
             })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function() {});
            },
            
    },// fin metodos
    
    
};
</script>

<style>
.padding{
  padding-bottom: 25px;
}

</style>
